<template>
	<v-dialog v-model="showEconomicForm" fullscreen persistent scrollable>
		<v-form ref="totalForm" v-model="isValidTotal">
			<v-card>
				<v-toolbar dark color="#c51f2f">
					<v-btn icon dark @click="closeEconomicForm">
						<v-icon>fas fa-times-circle</v-icon>
					</v-btn>
					<v-toolbar-title>Estudio socioeconómico</v-toolbar-title>
					<v-spacer></v-spacer>
					<v-toolbar-items>
						<v-btn dark text :disabled="economicData.family.length !== parseInt(economicData.personasViviendoEnLaCasa)" @click="getPDF">Guardar</v-btn>
					</v-toolbar-items>
				</v-toolbar>
				<v-card-text>
					<p class="headline text-center text-sm-center">Favor de llenar el siguiente cuestionario con datos reales.</p>
					<!-- Datos socioeconómicos -->
					<v-card class="mt-5 mb-5" outlined elevation="20">
						<v-card-title>Datos socioeconómicos</v-card-title>
						<v-card-text>
							<v-row>
								<v-col cols="12" sm="4">
									<v-text-field
										id="cap"
										v-model="economicData.ocupacion"
										label="Ocupación"
										prepend-icon="fas fa-school"
										outlined
										:rules="rulesRequired"
										required
									/>
								</v-col>
								<v-col cols="12" sm="4" v-if="economicData.ocupacion !== 'Estudiante' && economicData.ocupacion !== 'estudiante' && economicData.ocupacion !== ''">
									<v-text-field
										v-model="economicData.telefonoTrabajo"
										label="Teléfono de trabajo"
										type="number"
										min="0"
										prepend-icon="fas fa-phone"
										outlined
										required
										:rules="rulesPhones"
									/>
								</v-col>
								<v-col cols="12" sm="4" v-if="economicData.ocupacion !== 'Estudiante' && economicData.ocupacion !== 'estudiante' && economicData.ocupacion !== ''">
									<v-text-field
										v-model="economicData.sueldoMensual"
										label="Sueldo mensual"
										prepend-icon="fas fa-dollar-sign"
										outlined
										type="number"
										min="0"
										:rules="rulesRequired"
										required
									/>
								</v-col>
							</v-row>
							<v-row v-if="economicData.ocupacion !== 'Estudiante' && economicData.ocupacion !== 'estudiante' && economicData.ocupacion !== ''">
								<v-col cols="12" sm="6">
									<v-select
										v-model="hourStart"
										label="Hora de entrada"
										prepend-icon="fas fa-clock"
										outlined
										:items="itemsScheduleStart"
										:rules="rulesRequired"
										required
									/>
								</v-col>
								<v-col cols="12" sm="6">
									<v-select
										v-model="hourEnd"
										label="Hora de salida"
										prepend-icon="fas fa-clock"
										outlined
										:items="itemsScheduleEnd"
										:rules="rulesRequired"
										required
									/>
								</v-col>
							</v-row>
							<v-row justify="space-between">
								<v-col cols="12" sm="3">
									<p slot="label" class="title">Actualmente vives con:</p>
									<v-radio-group v-model="economicData.viveCon" row :rules="rulesRequired" required>
										<v-radio label="Padres" value="padres" />
										<v-radio label="Familiares" value="familiares" />
										<v-radio label="Amigos" value="amigos" />
										<v-radio label="Esposo(a)" value="conyuge" />
									</v-radio-group>
								</v-col>
								<v-col cols="12" sm="3">
									<v-text-field
										v-model="economicData.tiempoViviendoEnEseDomicilio"
										outlined
										prepend-icon="fas fa-hourglass"
										type="number"
										suffix="años"
										min="0"
										label="Tiempo viviendo ahí"
										:rules="rulesTimeInTheHouse"
										required
									/>
								</v-col>
								<v-col cols="12" sm="3">
									<v-text-field
										v-model="economicData.personasViviendoEnLaCasa"
										outlined
										prepend-icon="fas fa-users"
										type="number"
										label="Personas viviendo contigo"
										min="0"
										:rules="rulesRequired"
										required
									/>
								</v-col>
							</v-row>
							<v-row justify="space-between">
								<v-col cols="12" sm="3">
									<p slot="label" class="title">La casa donde vives es:</p>
									<v-radio-group
										row
										:rules="rulesRequired"
										required
										v-model="economicData.laCasaDondeViveEs"
									>
										<v-radio label="Propia" value="propia" />
										<v-radio label="Rentada" value="rentada" />
										<v-radio label="Casa de huéspedes" value="huespedes" />
										<v-radio label="Otro" value="otro" />
										<v-text-field v-if="economicData.laCasaDondeViveEs === 'otro'" v-model="other" label="Especifica" />
									</v-radio-group>
								</v-col>
								<v-col cols="12" sm="4">
									<p slot="label" class="title">El material del piso es:</p>
									<v-radio-group row v-model="economicData.materialDePiso" :rules="rulesRequired" required>
										<v-radio label="Tierra" value="tierra" />
										<v-radio label="Alfombra" value="alfombra" />
										<v-radio label="Madera" value="madera" />
										<v-radio label="Duela" value="duela" />
										<v-radio label="Cemento" value="cemento" />
										<v-radio label="Mosaico" value="mosaico" />
										<v-radio label="Otro" value="otro" />
										<v-text-field v-if="economicData.materialDePiso === 'otro'" v-model="otherMaterial" label="Especifica" />
									</v-radio-group>
								</v-col>
								<v-col cols="12" sm="3">
									<v-text-field
										v-model="economicData.numeroRecamaras"
										label="¿Cuántas recámaras tiene?"
										type="number"
										prepend-icon="fas fa-bed"
										outlined
										min="0"
										:rules="rulesRequired"
										required
									/>
								</v-col>
							</v-row>
							<v-row justify="space-between">
								<v-col cols="12" sm="3">
									<v-text-field
										v-model="economicData.numeroBanios"
										label="¿Cuántos baños tiene?"
										type="number"
										prepend-icon="fas fa-bath"
										outlined
										min="0"
										:rules="rulesRequired"
										required
									/>
								</v-col>
								<v-col cols="12" sm="2">
									<p slot="label" class="title">¿Tiene sala?</p>
									<v-radio-group row v-model="economicData.tieneSala" :rules="rulesRequired" required>
										<v-radio label="Si" value="Si" />
										<v-radio label="No" value="No" />
									</v-radio-group>
								</v-col>
								<v-col cols="12" sm="3">
									<p slot="label" class="title">¿Tiene cocina independiente?</p>
									<v-radio-group
										row
										v-model="economicData.tieneCocinaIndependiente"
										:rules="rulesRequired"
										required
									>
										<v-radio label="Si" value="Si" />
										<v-radio label="No" value="No" />
									</v-radio-group>
								</v-col>
								<v-col cols="12" sm="3">
									<v-text-field
										v-model="economicData.numeroCarros"
										label="¿Cuántos carros tienes?"
										type="number"
										prepend-icon="fas fa-car"
										outlined
										min="0"
										:rules="rulesRequired"
										required
									/>
								</v-col>
							</v-row>
							<!-- servicios -->
							<v-row justify="space-around">
								<v-col cols="12">
									<p class="title">¿Con que servicios cuenta?</p>
								</v-col>
								<v-checkbox label="Agua" value="agua" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="Luz" value="luz" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="Drenaje" value="drenaje" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="Pavimento" value="pavimento" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="Teléfono" value="telefono" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="Gas" value="gas" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="TV por cable" value="cable" v-model="economicData.serviciosQueTiene" />
								<v-checkbox label="Internet" value="internet" v-model="economicData.serviciosQueTiene" />
							</v-row>
							<!-- electrodomesticos -->
							<v-row justify="space-around">
								<v-col cols="12">
									<p class="title">Tienes en tu casa:</p>
								</v-col>
								<v-checkbox class="mx-3" label="DVD" value="dvd" v-model="economicData.enCasaTienes" />
								<v-checkbox
									class="mx-3"
									label="Televisión"
									value="television"
									v-model="economicData.enCasaTienes"
								/>
								<v-checkbox class="mx-3" label="Estufa" value="estufa" v-model="economicData.enCasaTienes" />
								<v-checkbox
									class="mx-3"
									label="Licuadora"
									value="licuadora"
									v-model="economicData.enCasaTienes"
								/>
								<v-checkbox
									class="mx-3"
									label="Lavadora"
									value="lavadora"
									v-model="economicData.enCasaTienes"
								/>
								<v-checkbox
									class="mx-3"
									label="Estéreo"
									value="estereo"
									v-model="economicData.enCasaTienes"
								/>
								<v-checkbox
									class="mx-3"
									label="Microondas"
									value="microondas"
									v-model="economicData.enCasaTienes"
								/>
								<v-checkbox
									class="mx-3"
									label="Computadora"
									value="computadora"
									v-model="economicData.enCasaTienes"
								/>
							</v-row>
							<v-row>
								<v-col cols="12" sm="6">
									<p class="title">¿Cuentas con seguro de gastos médicos?</p>
									<v-radio-group
										v-model="economicData.cuentasConSeguroDeGastosMedicos"
										row
										:rules="rulesRequired"
										required
									>
										<v-radio label="Si" value="Si" />
										<v-radio label="No" value="No" />
									</v-radio-group>
								</v-col>
								<v-col cols="12" sm="6">
									<p slot="label" class="title">¿Que transporte utilizas?</p>
									<v-radio-group
										row
										v-model="economicData.transporteQueUtilizas"
										:rules="rulesRequired"
										required
									>
										<v-radio label="Auto propio" value="autoPropio" />
										<v-radio label="Auto familiar" value="autoFamiliar" />
										<v-radio label="Motocicleta" value="motocicleta" />
										<v-radio label="Camión" value="camion" />
										<v-radio label="Taxi" value="taxi" />
										<v-radio label="Caminando" value="caminando" />
										<v-radio label="Otro" value="otro" />
										<v-text-field
											v-if="economicData.transporteQueUtilizas === 'otro'"
											v-model="otherTransport"
											label="Especifica"
										/>
									</v-radio-group>
								</v-col>
							</v-row>
						</v-card-text>
					</v-card>
					<!-- Datos familiares -->
					<v-form ref="formFamily" v-model="isValid">
						<v-card outlined elevation="20">
							<v-card-title>Datos familiares</v-card-title>
							<v-card-text>
								<v-row justify="space-between">
									<v-col cols="12" sm="3">
										<v-text-field
											v-model="family.name"
											prepend-icon="fas fa-address-card"
											label="Nombre completo"
											:rules="ruleNames"
											outlined
											required
										/>
									</v-col>
									<v-col cols="12" sm="3">
										<v-select
											v-model="family.parentesco"
											prepend-icon="fas fa-user-alt"
											label="Parentesco"
											:items="itemsRelationShip"
											outlined
											:rules="rulesRequired"
											required
										/>
									</v-col>
									<v-col cols="12" sm="3" v-if="family.parentesco === 'Otro'">
										<v-text-field
											v-model="otherRelationship"
											label="Especifica"
											prepend-icon="fas fa-user-alt"
											:rules="rulesRequired"
											outlined
											required />
									</v-col>
									<v-col cols="12" sm="3">
										<v-select
											v-model="family.civilState"
											prepend-icon="fas fa-user-alt"
											label="Estado civil"
											:items="itemsCivilState"
											outlined
											:rules="rulesRequired"
											required
										/>
									</v-col>
								</v-row>
								<v-row justify="space-between">
									<v-col cols="12" sm="2">
										<v-text-field
											label="Edad"
											suffix="años"
											prepend-icon="fas fa-sort-numeric-up"
											v-model="family.age"
											outlined
											:rules="rulesAge"
											type="number"
											min="0"
											required
										/>
									</v-col>
									<v-col cols="12" sm="3">
										<p slot="label" class="title">Selecciona un género</p>
										<v-radio-group v-model="family.gender" row prepend-icon="fa-venus-mars">
											<v-radio label="Hombre" value="Hombre" />
											<v-radio label="Mujer" value="Mujer" />
										</v-radio-group>
									</v-col>
									<v-col cols="12" sm="3">
										<v-select
											label="Escolaridad"
											v-model="family.scholarShip"
											outlined
											prepend-icon="fas fa-school"
											:items="itemsScholarShip"
											:rules="rulesRequired"
											required
										/>
									</v-col>
									<v-col cols="12" sm="3">
										<p slot="label" class="title">¿Terminó la carrera?</p>
										<v-radio-group
											v-model="family.completa"
											row
											prepend-icon="fa-school"
											:rules="rulesRequired"
										>
											<v-radio label="Si" value="Completa" />
											<v-radio label="No" value="Incompleta" />
										</v-radio-group>
									</v-col>
								</v-row>
								<v-row>
									<v-col cols="12" sm="2">
										<p slot="label" class="title">¿Trabaja?</p>
										<v-radio-group v-model="family.works" row :rules="rulesRequired">
											<v-radio label="Si" value="Si" />
											<v-radio label="No" value="No" />
										</v-radio-group>
									</v-col>
									<v-col cols="12" sm="3" v-if="family.works === 'Si'">
										<v-select
											label="Ocupación"
											v-model="family.ocupacion"
											prepend-icon="fas fa-chalkboard-teacher"
											outlined
											:rules="rulesRequired"
											:items="itemsProfesion"
											required
										/>
									</v-col>
									<v-col cols="12" sm="3" v-if="family.works === 'Si'">
										<v-text-field
											label="Lugar de trabajo"
											v-model="family.workPlace"
											prepend-icon="fas fa-building"
											outlined
											:rules="rulesRequired"
											required
										/>
									</v-col>
									<v-col cols="12" sm="3" v-if="family.works === 'Si'">
										<v-text-field
											label="Ingreso mensual"
											v-model="family.ingreso"
											prepend-icon="fas fa-dollar-sign"
											outlined
											type="number"
											min="0"
											:rules="rulesSalario"
											required
										/>
									</v-col>
								</v-row>
								<v-row justify="center">
									<v-col cols="12" sm="3">
										<v-btn
											:disabled="!isValid"
											outlined
											block
											color="green"
											@click="addPerson"
										>Agregar familiar</v-btn>
									</v-col>
								</v-row>
							</v-card-text>
							<v-card-actions>
								<v-data-table
									:loading="loadingTable"
									loading-text="Esperando datos"
									class="elevation-10"
									hide-default-footer
									:items="economicData.family"
									:headers="headerTable"
									:mobile-breakpoint="600"
								>
									<template v-slot:no-data>
										<p class="subtitle-1">No hay datos</p>
									</template>
									<template v-slot:item.action="{ item }">
										<v-tooltip top>
											<template v-slot:activator="{ on }">
												<v-btn
													text
													icon
													color="red"
													v-on="on"
													@click="deletePerson(item)"
												>
													<v-icon>fas fa-trash-alt</v-icon>
												</v-btn>
											</template>
											<span>Eliminar</span>
										</v-tooltip>
									</template>
								</v-data-table>
							</v-card-actions>
						</v-card>
					</v-form>
				</v-card-text>
			</v-card>
		</v-form>
	</v-dialog>
</template>

<script>
import gql from "graphql-tag";
import { mapState, mapMutations } from "vuex";
import axios from "axios";
import EventBus from "../../bus";

const date = new Date();
const currentDate = `${date.getDate()}/${date.getMonth() +
	1}/${date.getFullYear()}`;

export default {
	name: "FormEconomicData",
	props: ["showEconomicForm"],
	data: () => ({
		isValid: true,
		isValidTotal: true,
		disabledButtonForm:false,
		itemsScheduleStart: [],
		itemsScheduleEnd: [],
		hourStart: "",
		hourEnd: "",
		other: "",
		otherMaterial: "",
		otherTransport: "",
		otherRelationship:"",
		loadingTable: true,
		itemsRelationShip: ["Padre", "Madre", "Hermano(a)","Hijo(a)","Abuelo(a)","Tío(a)","Tutor(a)","Esposo(a)","Otro"],
		itemsCivilState: [
			"Soltero(a)",
			"Casado(a)",
			"Divorciado(a)",
			"Viudo(a)"
		],
		itemsScholarShip: [
			"Ninguno",
			"Primaria",
			"Secundaria",
			"Preparatoria",
			"Carrera técnica",
			"Licenciatura",
			"Maestría",
			"Posgrado"
		],
		itemsProfesion: [
			"Estudiante",
			"Hogar",
			"Comerciante",
			"Jubilado / Pensionado",
			"Obrero",
			"Técnico",
			"Profesionista",
			"Empleado",
			"Campo"
		],
		// Variable para el formulario socioeconomico
		economicData: {
			works: "No",
			ocupacion: "",
			telefonoTrabajo: "",
			horario: "",
			sueldoMensual: "",
			viveCon: "",
			tiempoViviendoEnEseDomicilio: "",
			personasViviendoEnLaCasa: "",
			laCasaDondeViveEs: "",
			materialDePiso: "",
			numeroRecamaras: "",
			numeroBanios: "",
			tieneSala: "",
			tieneCocinaIndependiente: "",
			serviciosQueTiene: [],
			enCasaTienes: [],
			numeroCarros: "",
			cuentasConSeguroDeGastosMedicos: "",
			transporteQueUtilizas: "",
			family: []
		},
		family: {
			name: "",
			parentesco: "",
			age: "",
			gender: "",
			civilState: "",
			scholarShip: "",
			completa: "",
			works: "",
			ocupacion: "",
			workPlace: "",
			ingreso: ""
		},
		headerTable: [
			{ text: "Nombre", value: "name" },
			{ text: "Parentesco", value: "parentesco", align: "center" },
			{ text: "Edad", value: "age", align: "center" },
			{ text: "Sexo", value: "gender", align: "center" },
			{ text: "Estado civil", value: "civilState", align: "center" },
			{ text: "Escolaridad", value: "scholarShip", align: "center" },
			{ text: "Carrera", value: "completa", align: "center" },
			{ text: "¿Trabaja?", value: "works", align: "center" },
			{ text: "Ocupación", value: "ocupacion", align: "center" },
			{
				text: "Lugar de trabajo",
				value: "workPlace",
				align: "center"
			},
			{
				text: "Ingreso mensual",
				value: "ingreso",
				align: "center"
			},
			{ text: "Acción", value: "action" }
		],
		ruleNames: [
			value => !!value || "Campo requerido",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'"1234567890,<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo permitidas letras";
			}
		],
		rulesPhones: [
			value => !!value || "Campo requerido",
			value => (value || "").length === 10 || "10 números obligatorios"
		],
		rulesAge: [
			value => !!value || "Campo requerido",
			value => (value > 0 && value <= 100) || "Ingrese la edad real"
		],
		rulesTimeInTheHouse: [
			value => !!value || "Campo requerido",
			value => (value > 0 && value <= 100) || "Ingrese la edad real"
		],
		rulesSalario: [
			value => !!value || "Campo requerido",
			value => value > 0 || "Ingresos mayores a $0"
		],
		rulesRequired: [value => !!value || "Campo requerido"]
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),
		// Hace una copia de la variable family para guardarla en el objeto a enviar
		copy(data) {
			let values = {};
			for (let i in data) {
				values[i] = data[i];
			}
			return values;
		},
		// Agregar nueva persona
		addPerson() {
			if(this.family.parentesco === "Otro"){
				this.family.parentesco = this.otherRelationship;
			}
			let copyOfObjectToSend = this.copy(this.family);
			this.economicData.family.push(copyOfObjectToSend);
			this.$refs.formFamily.reset();
			this.loadingTable = false;
		},
		// Elimina el familiar seleccionado
		deletePerson(fam) {
			const index = this.economicData.family.indexOf(fam);
			this.economicData.family.splice(index, 1);
		},
		// envia la información
		async getPDF() {
			switch(this.economicData.ocupacion){
				case "Estudiante":
					this.economicData.works = "No";
					break;
				case "estudiante":
					this.economicData.works = "No";
					break;
				default:
					this.economicData.works = "Si";
					break;
			}
			if (this.economicData.laCasaDondeViveEs === "otro") {
				this.economicData.laCasaDondeViveEs = this.other;
			}
			if (this.economicData.materialDePiso === "otro") {
				this.economicData.materialDePiso = this.otherMaterial;
			}
			if (this.economicData.transporteQueUtilizas === "otro") {
				this.economicData.transporteQueUtilizas = this.otherTransport;
			}
			this.economicData.horario = `${this.hourStart} - ${this.hourEnd}`;
			this.economicData.ingreso = parseInt(this.economicData.ingreso, 10);
			this.family.ingreso = parseInt(this.family.ingreso, 10);
			try {
				// Ruta que guarda el PDF en la BD
				await axios.post("/socioeconomicPDF", this.economicData, {
					headers: {
						Authorization: sessionStorage.getItem("token")
					}
				});

				// Ruta que obtiene el PDF
				const response = await axios.get("/socioeconomicPDF/obtain", {
					responseType: "blob",
					headers: {
						Accept: "application/pdf",
						Authorization: sessionStorage.getItem("token")
					}
				});

				const url = window.URL.createObjectURL(
					new Blob([response.data])
				);
				const link = document.createElement("a");
				link.href = url;
				link.setAttribute("download", "EstudioSocioeconomico.pdf");
				document.body.appendChild(link);
				link.click();
			} catch (error) {
				console.error(error);
			}
		},
		// cierra el formulario socioeconomico
		closeEconomicForm() {
			EventBus.$emit("closeEconomicForm");
		}
	},
	mounted() {
		// Llena el select de la hora
		let valueItem = "";
		for (let i = 7; i < 13; i++) {
			valueItem = "0" + i + ":00";
			this.itemsScheduleStart.push(valueItem);
		}
		let newData = this.itemsScheduleStart.slice(3);
		this.itemsScheduleStart.splice(3, 3);
		for (let j of newData) {
			this.itemsScheduleStart.push(j.substring(1));
		}

		// Llena el select de la hora de salida
		let valueItems2 = "";
		for (let k = 15; k < 21; k++) {
			valueItems2 = k + ":00";
			this.itemsScheduleEnd.push(valueItems2);
		}

		// cierra el formulario socioeconomico con la tecla ESC
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeEconomicForm();
			}
		});
	}
};
</script>

<style scoped>
	#cap{
		text-transform: capitalize;
	}
</style>